require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_X86_64_PGTABLE_H)) {
    eval 'sub _X86_64_PGTABLE_H () {1;}' unless defined(&_X86_64_PGTABLE_H);
    require 'asm/processor.ph';
    require 'asm/fixmap.ph';
    require 'asm/bitops.ph';
    require 'linux/threads.ph';
    require 'asm/pda.ph';
    eval 'sub swapper_pg_dir () { &NULL;}' unless defined(&swapper_pg_dir);
    eval 'sub ZERO_PAGE {
        local($vaddr) = @_;
	    eval q(( &virt_to_page( &empty_zero_page)));
    }' unless defined(&ZERO_PAGE);
    eval 'sub PML4_SHIFT () {39;}' unless defined(&PML4_SHIFT);
    eval 'sub PTRS_PER_PML4 () {512;}' unless defined(&PTRS_PER_PML4);
    eval 'sub PGDIR_SHIFT () {30;}' unless defined(&PGDIR_SHIFT);
    eval 'sub PTRS_PER_PGD () {512;}' unless defined(&PTRS_PER_PGD);
    eval 'sub PMD_SHIFT () {21;}' unless defined(&PMD_SHIFT);
    eval 'sub PTRS_PER_PMD () {512;}' unless defined(&PTRS_PER_PMD);
    eval 'sub PTRS_PER_PTE () {512;}' unless defined(&PTRS_PER_PTE);
    eval 'sub pte_ERROR {
        local($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pte %p(%016lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pte_val($e)));
    }' unless defined(&pte_ERROR);
    eval 'sub pmd_ERROR {
        local($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pmd %p(%016lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pmd_val($e)));
    }' unless defined(&pmd_ERROR);
    eval 'sub pgd_ERROR {
        local($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pgd %p(%016lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pgd_val($e)));
    }' unless defined(&pgd_ERROR);
    eval 'sub pml4_none {
        local($x) = @_;
	    eval q((! &pml4_val($x)));
    }' unless defined(&pml4_none);
    eval 'sub pgd_none {
        local($x) = @_;
	    eval q((! &pgd_val($x)));
    }' unless defined(&pgd_none);
1;
