require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_MD_K_H)) {
    eval 'sub _MD_K_H () {1;}' unless defined(&_MD_K_H);
    eval 'sub MD_RESERVED () {0;}' unless defined(&MD_RESERVED);
    eval 'sub LINEAR () {1;}' unless defined(&LINEAR);
    eval 'sub RAID0 () {2;}' unless defined(&RAID0);
    eval 'sub RAID1 () {3;}' unless defined(&RAID1);
    eval 'sub RAID5 () {4;}' unless defined(&RAID5);
    eval 'sub TRANSLUCENT () {5;}' unless defined(&TRANSLUCENT);
    eval 'sub HSM () {6;}' unless defined(&HSM);
    eval 'sub MULTIPATH () {7;}' unless defined(&MULTIPATH);
    eval 'sub RAID6 () {8;}' unless defined(&RAID6);
    eval 'sub MAX_PERSONALITY () {9;}' unless defined(&MAX_PERSONALITY);
    eval 'sub LEVEL_MULTIPATH () {(-4);}' unless defined(&LEVEL_MULTIPATH);
    eval 'sub LEVEL_LINEAR () {(-1);}' unless defined(&LEVEL_LINEAR);
    eval 'sub MaxSector () {(~0);}' unless defined(&MaxSector);
    eval 'sub MD_THREAD_NAME_MAX () {14;}' unless defined(&MD_THREAD_NAME_MAX);
    eval 'sub MAX_MD_DEVS () {256;}' unless defined(&MAX_MD_DEVS);
    eval 'sub MAX_CHUNK_SIZE () {(4096*1024);}' unless defined(&MAX_CHUNK_SIZE);
    eval 'sub MD_RECOVERY_RUNNING () {0;}' unless defined(&MD_RECOVERY_RUNNING);
    eval 'sub MD_RECOVERY_SYNC () {1;}' unless defined(&MD_RECOVERY_SYNC);
    eval 'sub MD_RECOVERY_ERR () {2;}' unless defined(&MD_RECOVERY_ERR);
    eval 'sub MD_RECOVERY_INTR () {3;}' unless defined(&MD_RECOVERY_INTR);
    eval 'sub MD_RECOVERY_DONE () {4;}' unless defined(&MD_RECOVERY_DONE);
    eval 'sub MD_RECOVERY_NEEDED () {5;}' unless defined(&MD_RECOVERY_NEEDED);
    eval 'sub ITERATE_RDEV_GENERIC {
        local($head,$rdev,$tmp) = @_;
	    eval q( &for (($tmp) = ($head). &next; ($rdev) = ( &list_entry(($tmp),  &mdk_rdev_t,  &same_set)), ($tmp) = ($tmp)-> &next, ($tmp)-> &prev != ($head) ; ));
    }' unless defined(&ITERATE_RDEV_GENERIC);
    eval 'sub ITERATE_RDEV {
        local($mddev,$rdev,$tmp) = @_;
	    eval q( &ITERATE_RDEV_GENERIC(($mddev)-> &disks,$rdev,$tmp));
    }' unless defined(&ITERATE_RDEV);
    eval 'sub ITERATE_RDEV_PENDING {
        local($rdev,$tmp) = @_;
	    eval q( &ITERATE_RDEV_GENERIC( &pending_raid_disks,$rdev,$tmp));
    }' unless defined(&ITERATE_RDEV_PENDING);
    eval 'sub THREAD_WAKEUP () {0;}' unless defined(&THREAD_WAKEUP);
    eval 'sub __wait_event_lock_irq {
        local($wq, $condition, $lock, $cmd) = @_;
	    eval q( &do {  &wait_queue_t  &__wait;  &init_waitqueue_entry(& &__wait,  &current);  &add_wait_queue($wq, & &__wait);  &for (;;) {  &set_current_state;  &if  &break;  &spin_unlock_irq($lock); $cmd;  &schedule();  &spin_lock_irq($lock); }  ($current->{state}) =  &TASK_RUNNING;  &remove_wait_queue($wq, & &__wait); }  &while (0));
    }' unless defined(&__wait_event_lock_irq);
    eval 'sub wait_event_lock_irq {
        local($wq, $condition, $lock, $cmd) = @_;
	    eval q( &do {  &if  &break;  &__wait_event_lock_irq($wq, $condition, $lock, $cmd); }  &while (0));
    }' unless defined(&wait_event_lock_irq);
}
1;
