require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_RMAP_H)) {
    eval 'sub _LINUX_RMAP_H () {1;}' unless defined(&_LINUX_RMAP_H);
    require 'linux/config.ph';
    require 'linux/linkage.ph';
    eval 'sub rmap_lock {
        local($page) = @_;
	    eval q( &bit_spin_lock( &PG_maplock, ($page)-> &flags));
    }' unless defined(&rmap_lock);
    eval 'sub rmap_unlock {
        local($page) = @_;
	    eval q( &bit_spin_unlock( &PG_maplock, ($page)-> &flags));
    }' unless defined(&rmap_unlock);
    if(defined(&CONFIG_MMU)) {
    } else {
	eval 'sub page_referenced {
	    local($page) = @_;
    	    eval q( &TestClearPageReferenced($page));
	}' unless defined(&page_referenced);
	eval 'sub try_to_unmap {
	    local($page) = @_;
    	    eval q( &SWAP_FAIL);
	}' unless defined(&try_to_unmap);
    }
    eval 'sub SWAP_SUCCESS () {0;}' unless defined(&SWAP_SUCCESS);
    eval 'sub SWAP_AGAIN () {1;}' unless defined(&SWAP_AGAIN);
    eval 'sub SWAP_FAIL () {2;}' unless defined(&SWAP_FAIL);
}
1;
