require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__CAPIUTIL_H__)) {
    eval 'sub __CAPIUTIL_H__ () {1;}' unless defined(&__CAPIUTIL_H__);
    require 'asm/types.ph';
    eval 'sub CAPIMSG_BASELEN () {8;}' unless defined(&CAPIMSG_BASELEN);
    eval 'sub CAPIMSG_U8 {
        local($m, $off) = @_;
	    eval q(($m->[$off]));
    }' unless defined(&CAPIMSG_U8);
    eval 'sub CAPIMSG_U16 {
        local($m, $off) = @_;
	    eval q(($m->[$off]|($m->[($off)+1]<<8)));
    }' unless defined(&CAPIMSG_U16);
    eval 'sub CAPIMSG_U32 {
        local($m, $off) = @_;
	    eval q(($m->[$off]|($m->[($off)+1]<<8)|($m->[($off)+2]<<16)|($m->[($off)+3]<<24)));
    }' unless defined(&CAPIMSG_U32);
    eval 'sub CAPIMSG_LEN {
        local($m) = @_;
	    eval q( &CAPIMSG_U16($m,0));
    }' unless defined(&CAPIMSG_LEN);
    eval 'sub CAPIMSG_APPID {
        local($m) = @_;
	    eval q( &CAPIMSG_U16($m,2));
    }' unless defined(&CAPIMSG_APPID);
    eval 'sub CAPIMSG_COMMAND {
        local($m) = @_;
	    eval q( &CAPIMSG_U8($m,4));
    }' unless defined(&CAPIMSG_COMMAND);
    eval 'sub CAPIMSG_SUBCOMMAND {
        local($m) = @_;
	    eval q( &CAPIMSG_U8($m,5));
    }' unless defined(&CAPIMSG_SUBCOMMAND);
    eval 'sub CAPIMSG_CMD {
        local($m) = @_;
	    eval q(((($m->[4])<<8)|($m->[5])));
    }' unless defined(&CAPIMSG_CMD);
    eval 'sub CAPIMSG_MSGID {
        local($m) = @_;
	    eval q( &CAPIMSG_U16($m,6));
    }' unless defined(&CAPIMSG_MSGID);
    eval 'sub CAPIMSG_CONTROLLER {
        local($m) = @_;
	    eval q(($m->[8] & 0x7f));
    }' unless defined(&CAPIMSG_CONTROLLER);
    eval 'sub CAPIMSG_CONTROL {
        local($m) = @_;
	    eval q( &CAPIMSG_U32($m, 8));
    }' unless defined(&CAPIMSG_CONTROL);
    eval 'sub CAPIMSG_NCCI {
        local($m) = @_;
	    eval q( &CAPIMSG_CONTROL($m));
    }' unless defined(&CAPIMSG_NCCI);
    eval 'sub CAPIMSG_DATALEN {
        local($m) = @_;
	    eval q( &CAPIMSG_U16($m,16));
    }' unless defined(&CAPIMSG_DATALEN);
    eval 'sub CAPIMSG_SETLEN {
        local($m, $len) = @_;
	    eval q( &capimsg_setu16($m, 0, $len));
    }' unless defined(&CAPIMSG_SETLEN);
    eval 'sub CAPIMSG_SETAPPID {
        local($m, $applid) = @_;
	    eval q( &capimsg_setu16($m, 2, $applid));
    }' unless defined(&CAPIMSG_SETAPPID);
    eval 'sub CAPIMSG_SETCOMMAND {
        local($m,$cmd) = @_;
	    eval q( &capimsg_setu8($m, 4, $cmd));
    }' unless defined(&CAPIMSG_SETCOMMAND);
    eval 'sub CAPIMSG_SETSUBCOMMAND {
        local($m, $cmd) = @_;
	    eval q( &capimsg_setu8($m, 5, $cmd));
    }' unless defined(&CAPIMSG_SETSUBCOMMAND);
    eval 'sub CAPIMSG_SETMSGID {
        local($m, $msgid) = @_;
	    eval q( &capimsg_setu16($m, 6, $msgid));
    }' unless defined(&CAPIMSG_SETMSGID);
    eval 'sub CAPIMSG_SETCONTROL {
        local($m, $contr) = @_;
	    eval q( &capimsg_setu32($m, 8, $contr));
    }' unless defined(&CAPIMSG_SETCONTROL);
    eval 'sub CAPIMSG_SETDATALEN {
        local($m, $len) = @_;
	    eval q( &capimsg_setu16($m, 16, $len));
    }' unless defined(&CAPIMSG_SETDATALEN);
    eval("sub CAPI_COMPOSE () { 0; }") unless defined(&CAPI_COMPOSE);
    eval("sub CAPI_DEFAULT () { 1; }") unless defined(&CAPI_DEFAULT);
}
1;
