require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_NFSD_XDR4_H)) {
    eval 'sub _LINUX_NFSD_XDR4_H () {1;}' unless defined(&_LINUX_NFSD_XDR4_H);
    eval 'sub NFSD4_MAX_TAGLEN () {128;}' unless defined(&NFSD4_MAX_TAGLEN);
    eval 'sub XDR_LEN {
        local($n) = @_;
	    eval q(((($n) + 3) & ~3));
    }' unless defined(&XDR_LEN);
    eval 'sub cr_linklen () { ($u->{link}->{namelen});}' unless defined(&cr_linklen);
    eval 'sub cr_linkname () { ($u->{link}->{name});}' unless defined(&cr_linkname);
    eval 'sub cr_specdata1 () { ($u->{dev}->{specdata1});}' unless defined(&cr_specdata1);
    eval 'sub cr_specdata2 () { ($u->{dev}->{specdata2});}' unless defined(&cr_specdata2);
    eval 'sub lk_new_open_seqid () { ($v->{new}->{open_seqid});}' unless defined(&lk_new_open_seqid);
    eval 'sub lk_new_open_stateid () { ($v->{new}->{open_stateid});}' unless defined(&lk_new_open_stateid);
    eval 'sub lk_new_lock_seqid () { ($v->{new}->{lock_seqid});}' unless defined(&lk_new_lock_seqid);
    eval 'sub lk_new_clientid () { ($v->{new}->{clientid});}' unless defined(&lk_new_clientid);
    eval 'sub lk_new_owner () { ($v->{new}->{owner});}' unless defined(&lk_new_owner);
    eval 'sub lk_old_lock_stateid () { ($v->{old}->{lock_stateid});}' unless defined(&lk_old_lock_stateid);
    eval 'sub lk_old_lock_seqid () { ($v->{old}->{lock_seqid});}' unless defined(&lk_old_lock_seqid);
    eval 'sub lk_rflags () { ($u->{ok}->{rflags});}' unless defined(&lk_rflags);
    eval 'sub lk_resp_stateid () { ($u->{ok}->{stateid});}' unless defined(&lk_resp_stateid);
    eval 'sub lk_denied () { ($u->{denied});}' unless defined(&lk_denied);
    eval 'sub op_iattr () { ($u->{iattr});}' unless defined(&op_iattr);
    eval 'sub op_verf () { ($u->{verf});}' unless defined(&op_verf);
    eval 'sub NFS4_SVC_XDRSIZE () {$sizeof{\'struct nfsd4_compoundargs\'};}' unless defined(&NFS4_SVC_XDRSIZE);
}
1;
